import sys
import os
sys.path.append("lib")

from soarapp import PROGRAM_NAME, pwd

PROGRAM_NAME = PROGRAM_NAME.lower()

Numworks = False
try:
	import Numeric
	Numworks = True
except ImportError:
	print "You may have to install Numeric manually.. trying automatically first"
	try:
		if os.name == "posix":
			os.popen("python lib/Numeric-24.2/setup.py config")
			os.popen("python lib/Numeric-24.2/setup.py install")
		elif os.name == "nt":
			os.popen("python lib\\Numeric-24.2\\setup.py config")
			os.popen("python lib\\Numeric-24.2\\setup.py install")
	except:
		print "You must install Numeric manually first or some of the labs will not work"

def updateExec(filename):
	readfromfile = open(filename, 'r').readlines()
	readfromfile[0] = "#!" + sys.executable + "\n"
	f = open(filename, 'w')
	f.writelines(readfromfile)
	f.close()
updateExec(PROGRAM_NAME+".py")
updateExec("manual.py")
configlines=[]
configlines.append("MANLOC = \"file://" + pwd() + "/manual/index.html\"\n")
if os.name == "nt":
	port = "com0"
elif os.name == "posix":
	trial = os.popen("ls /dev/ttyS0").readlines()
	if len(trial) > 0:
		port = "/dev/ttyS0" 
	else:
		port = "/dev/ttyUSB0"
configlines.append("SERIAL_PORT_NAME = \"" + port  + "\"\n")
f = open("src/config.py", 'w')
f.writelines(configlines)
f.close()
if os.name == "posix":
	os.popen("chmod a+x " + PROGRAM_NAME + ".py")
	print "It looks to me like everything installed ok. You should now be able to run ./" + PROGRAM_NAME + ".py in this directory"
elif os.name == "nt":
	print "It looks to me like everything installed ok. You should now be able to double-click " + PROGRAM_NAME + ".py, which is in " + pwd() + " to run the program. Making a desktop shortcut to this file might save you some time."
open("$HOME/.emacs", 'a').write("(global-font-lock-mode 1)\n")
print "If you get serial errors when trying to use the Pioneer functionality, I probably configured the wrong port for you. Try changing the appropriate line in src/config.py"
if not Numworks:
	print "If you get errors like \"ImportError: No module named Numeric\" when you are running some of the later labs, you probably need to install Numeric manually. see http://sourceforge.net/project/showfiles.php?group_id=1369 and make sure to download the appropriate release of Numeric, NOT NumArray or Numpy"
